#include <iostream>

using namespace std;
int mat[10000][4];
int pacijenti[10000][2];
int main()
{
    int n;

    int imaO;
    int imaA;
    int imaB;
    int imaAB;

    int O=0;
    int A=0;
    int B=0;
    int AB=0;

    int brPac=0;

    string grupa;
    int broj;

    cin >> n;
    cin >> imaO >> imaA >> imaB >> imaAB;


    for(int i = 0; i < n; i++)
    {
        cin >> grupa >> broj;
        if (grupa == "O")
        {
            if(broj > imaO){
                printf("nemoguce\n");
                return 0;
            }
            imaO -= broj;
            mat[i][0] = broj;
            mat[i][1] = 0;
            mat[i][2] = 0;
            mat[i][3] = 0;
        }
        else if(grupa == "A")
        {
            if(broj > imaA){
            mat[i][1] = imaA;
            broj-=imaA;
            imaA = 0;
            if(broj > imaO){
                printf("nemoguce\n");
                return 0;
            }
            mat[i][0] = broj;
            imaO-=broj;
            mat[i][2] = 0;
            mat[i][3] = 0;
            }else{
            mat[i][0] = 0;
            mat[i][1] = broj;
            mat[i][2] = 0;
            mat[i][3] = 0;
            imaA -= broj;
            }

        }
        else if(grupa == "B")
        {
        if(broj > imaB){
            mat[i][2] = imaB;
            broj-=imaB;
            imaB = 0;
            if(broj > imaO){
                printf("nemoguce\n");
                return 0;
            }
            mat[i][0] = broj;
            imaO-=broj;
            mat[i][1] = 0;
            mat[i][3] = 0;
            }else{
            mat[i][0] = 0;
            mat[i][1] = 0;
            mat[i][2] = broj;
            mat[i][3] = 0;
            imaB -= broj;
            }
        }
        else if(grupa == "AB")
        {

            if(broj > imaAB){
                pacijenti[brPac][0] = broj;
                pacijenti[brPac][1] = i;
                brPac++;
            }else{
            mat[i][0] = 0;
            mat[i][1] = 0;
            mat[i][2] = 0;
            mat[i][3] = broj;
            imaAB -= broj;
            }
        }
    }
    for (int i=0;i<brPac;i++){
        int broj = pacijenti[i][0];
        int index = pacijenti[i][1];
        mat[index][0] = 0;
        mat[index][1] = 0;
        mat[index][2] = 0;
        mat[index][3] = imaAB;
        broj -= imaAB;
        imaAB = 0;
        if (broj > imaA){
            mat[index][1] = imaA;
            broj-=imaA;
            imaA = 0;
        }else{
        mat[index][1] = broj;
        imaA -= broj;
        continue;
        }
        if (broj > imaB){
            mat[index][2] = imaB;
            broj-=imaB;
            imaB = 0;
        }else{
        mat[index][2] = broj;
        imaB -= broj;
        continue;
        }
        if (broj > imaO){
            printf("nemoguce\n");
                return 0;
        }else{
        mat[index][0] = broj;
        imaO -= broj;
        continue;
        }

    }
        cout << "moguce" << endl;
        for (int i =0; i < n; i++){
            cout << mat[i][0] << " " << mat[i][1] << " "<< mat[i][2] << " "<< mat[i][3] <<endl;
        }
    return 0;
}